/* Marc Chan modified 2012/04/05 (Generate simulation results for table 5) */
/* Table 5: Sample participation rates by time limit and work requirement policies */
/* this file reads simulation output and produce tables */
options pagesize=43 font="courier new" 8;
%let path=I:\tl2010\fortrancode\basemodel\simulation_results\table5\;
libname dataout "i:\tl2010";

/* read simulation output */
data temp;
	infile "&path.simulate4.txt";
	length default=4;
	input id simno swave type4 choice4 wage4 util4 ben14 ben24 ben34 ben44 cumafdcdata hit cumhitwait gcount wlin;
	* value1 value2 value3 value4 value5 value6 value7 value8 ev1 ev2 ev3 ev4 ev5 ev6 ev7 ev8 hit;
	*swave=swave+1;
run;
data temp;
	set temp;
	keep id simno swave type4 choice4;
run;

/* merge with SIPP data and merge in tlcurrent, sanction2, sanction3 */
proc sql;
	create table temp3 as
	select p.*, l.tlcurrent, l.sanction2, l.sanction3
	from temp as p left join dataout.fstatic as l
	on p.id = l.id & p.swave = l.swave;
quit;
data temp3;
	set temp3;
	length default=4;
	worknew=(choice4 in (2,3,5,7,8))*100;
	workfull=(choice4 in (3,8))*100;
	afdcnew=(choice4 in (4,5))*100;
	fsnew=(choice4 in (4,5,6,7,8))*100;
	wr = (sanction2=1 | sanction3=1)*100;
	tlcurrent=tlcurrent*100;
run;
ods html style=minimal;
proc tabulate data=temp3;
	class tlcurrent wr;
	var worknew workfull afdcnew fsnew;
	table (worknew workfull afdcnew fsnew)*mean*f=5.1, tlcurrent=''*wr='' all;
	where swave>=2;
run;
ods html close;
