/* Marc Chan modified 2012/03/26; 2012/04/09 */
/* this file reads simulation output and produce tables for policy effects */
/* NOTE: this file is used for long rum simulation of time limits */
options pagesize=43 linesize=150 font="courier new" 8;
*libname policy "i:\tl2010\otherpolicydata";

/* choose destination path */
%let path=I:\tl2010\fortrancode\basemodel\simulation_results\lr_strdynamic\;
*%let path=I:\tl2010\fortrancode\basemodel\simulation_results\lr_strstatic\;
*%let path=I:\tl2010\fortrancode\basemodel\simulation_results\lr_rfdynamic\;
*%let path=I:\tl2010\fortrancode\basemodel\simulation_results\lr_strdynamic_wr\;
*%let path=I:\tl2010\fortrancode\basemodel\simulation_results\lr_strdynamic_hour\;
*%let path=I:\tl2010\fortrancode\basemodel\simulation_results\lr_strdynamic_wtax\;
*%let path=I:\tl2010\fortrancode\basemodel\simulation_results\lr_strdynamic_ny\;

libname lr "&path";

/* choose whether to load linear utility model simulation data */
%let lin=;
%let lin=lin_;		* assume linear utility;

/* choose scenarios to load */
/* rfdynamic and strdynamic alternative data models only */
data filelist;
	infile datalines;
	length fname $40;
	input fname $;
	call symput ('num_files',_n_);
datalines;
&path.simulate4_&lin.1.txt
&path.simulate4_&lin.2.txt
&path.simulate4_&lin.3.txt
&path.simulate4_&lin.4.txt
&path.simulate4_&lin.5.txt
&path.simulate4_&lin.6.txt
&path.simulate4_&lin.7.txt
&path.simulate4_&lin.8.txt
&path.simulate4_&lin.9.txt
&path.simulate4_&lin.10.txt
;
run;
%put &num_files;

/* other models */
data filelist;
	infile datalines;
	length fname $40;
	input fname $;
	call symput ('num_files',_n_);
datalines;
&path.simulate4_&lin.1.txt
&path.simulate4_&lin.2.txt
&path.simulate4_&lin.3.txt
&path.simulate4_&lin.4.txt
&path.simulate4_&lin.5.txt
&path.simulate4_&lin.6.txt
&path.simulate4_&lin.7.txt
&path.simulate4_&lin.8.txt
&path.simulate4_&lin.9.txt
&path.simulate4_&lin.10.txt
&path.simulate4_&lin.11.txt
&path.simulate4_&lin.12.txt
&path.simulate4_&lin.13.txt
;
run;
%put &num_files;
/*
data filelist;
	infile datalines;
	length fname $40;
	input fname $;
	call symput ('num_files',_n_);
datalines;
&path.simulate4_&lin.14.txt
;
run;
%put &num_files;
*/

%macro readfiles;
%do iloop=1 %to &num_files;
/*%do iloop=9 %to 9;*/

data _null_;
	set filelist;
	if _n_=&iloop;
	call symput ('filein',fname);
run;
%put &filein;

/* simulate counterfactual policy environments */
data temp;
	infile "&filein";
	length default=4;
	input id simno swave type4 choice4 wage4 util4 ben14 ben24 ben34 ben44 cumafdcdata hit cumhitwait gcount wlin;
	* value1 value2 value3 value4 value5 value6 value7 value8 ev1 ev2 ev3 ev4 ev5 ev6 ev7 ev8 hit;
	*swave=swave+1;
run;

data simout&lin.&iloop;
/*data simout1;*/
	set temp;
	by id simno swave;
	length default=4;
	work=(choice4 in (2,3,5,7,8));
	workfull=(choice4 in (3,8));
	afdc=(choice4 in (4,5));
	fs=(choice4 in (4,5,6,7,8));
	hour=(choice4 in (2,5,7))*20+(choice4 in (3,8))*40;
	workmth= (choice4 in (2,5,7))*0.5+(choice4 in (3,8))*1;
	earn=wage4*workmth*2;
	joboffer=(wage4>0);
	if wage4=0 then wage4=.;
	disconnect=(choice4=1);
	hwage=wage4/80;	/* hourly wage offer */
	ben=ben14+ben24+ben34+ben44;

	if first.simno then do;
		cumafdc=afdc;
		cumworkmth=workmth;
		cumearn=earn;
		cumutil4=util4;
		cumben=ben;
		cumfs=fs;		* added 2012/01/20;
		cumben1=ben14;
		cumben2=ben24;
		cumben3=ben34;
		cumben4=ben44;
	end;
	else do;
		cumworkmth+workmth;
		cumafdc+afdc;
		cumfs+fs;		* added 2012/01/20;
		cumearn+earn*0.953**(swave-2);
		cumben+ben*	0.953**(swave-2);
		cumutil4+util4*	0.953**(swave-2);
		*cumwelfareben+welfareben*	0.953**(swave-2);
		cumben1+ben14*	0.953**(swave-2);
		cumben2+ben24*	0.953**(swave-2);
		cumben3+ben34*	0.953**(swave-2);
		cumben4+ben44*	0.953**(swave-2);
	end;
	nowelfare=(cumafdc=0);
	lagwork = lag(work);
	if first.simno then lagwork=.;
run;

data simout&lin.&iloop;
	set simout&lin.&iloop;
	length default=4;
	cumworkmth=cumworkmth/3;	* express in years;
	cumafdc=cumafdc/3; 			* express in years;
	cumfs=cumfs/3;				* added 2012/01/20;
	work=work*100;				* express in percentage;
	workfull=workfull*100; 		* express in percentage;
	afdc=afdc*100; 				* express in percentage;
	fs=fs*100; 					* express in percentage;
	disconnect=disconnect*100;  * express in percentage;
	nowelfare=nowelfare*100; 	* express in percentage;
	hit=hit*100; 				* express in percentage;
	amortr = 0.049031458*(1+0.049031458)**(swave-1)/ ( (1+0.049031458)**(swave-1) -1 );
	cumearn=cumearn*amortr;
	cumben=cumben* amortr;
	cumutil4=cumutil4* amortr;
	cumben1=cumben1*amortr;
	cumben2=cumben2*amortr;
	cumben3=cumben3*amortr;
	cumben4=cumben4*amortr;
	cf=&iloop;					* counterfactual index;
run;

%end;
%mend;

%readfiles;

data simout&lin;
	set _null_;
run;
%macro stackfiles;
%do iloop=1 %to &num_files;
data simout&lin;
	set simout&lin simout&lin.&iloop;
	if swave in (2,15,30);
run;
%end;
%mend;

%stackfiles;

PROC FORMAT;
  VALUE  cf 
	1="1) Baseline"
	2="2) 5yr TL"
	3="3) 5yr TL myopia"
	4="4) 4-4 nonlife TL"
	5="5) 30-pct ben cut"
	6="6) WR interm"
	7="7) EITC (1999)"
	8="8) Work subsidy"
	9="9) 1ppt drop unemp"
	10="10) TL, WR, EITC"
	11="11) 3-5 nonlife TL"
	12="12)	5-5 nonlife TL"
	13="13) 3-3 nonlife TL"
	;
RUN;

data simout&lin;
	set simout&lin;
	length default=4;
	format cf cf.;
	label
	work='Work (pct)'
	workfull= 'Full-time work (pct)'
	afdc='Welfare (pct)'
	fs='Food stamp (pct)'
	disconnect='Disconnected'
	nowelfare='Never on welfare (pct)'
	hit='Hit time limit (pct)'
	cumworkmth='Cum. effective work year'
	cumafdc='Cum. welfare year'
	cumfs='Cum. food stp year'
	cumearn='Amort. earnings (month $)'
	cumwelfareben='Amort. welfare benefit (month $)'
	cumben='Amort. net revenue cost (month $)'
	cumutil4='Amort. utility (month $)'
	cumben1=' Amort. welfare benefit (month $)'
	cumben2=' Amort. food stamp benefit (month $)'
	cumben3=' Amort. EITC/work subsidy benefit (month $)'
	cumben4=' Amort. tax (month $)'
	; 		*cumfs added 2012/01/12;
	year=.;
	if swave=2 then year=0;
	if swave=15 then year=5;
	if swave=30 then year=10;
run;

/******************************************************************/
/* Table 10: long-run simulation */
ods html style=minimal ;
proc tabulate data=simout&lin missing format=8.3 ;
	class year cf;
	var work workfull afdc fs cumearn cumben cumutil4;
	table (work workfull afdc fs cumearn cumben cumutil4)*year=''*f=7.2, cf=''*(mean='');
	title;
run;
proc tabulate data=simout&lin missing format=8.3 ;
	class year cf;
	var cumworkmth cumafdc cumfs hit disconnect nowelfare;
	table (cumworkmth cumafdc cumfs hit disconnect nowelfare)*year=''*f=7.2 , cf=''*(mean='');
	title;
	where year in (5,10);
run;
/*proc tabulate data=simout&lin missing format=8.3 ;
	class year cf;
	var disconnect nowelfare cumearn; * cumben1 cumben2 cumben3 cumben4;
	table (disconnect nowelfare cumearn)*year=''*f=7.2 , cf=''*(mean=''); *(cumearn cumben1 cumben2 cumben3 cumben4)*f=7.2);
	title;
	where year in (10);
run;*/
ods html close;

/* Long-run simulation selected results */
ods html style=minimal ;
proc tabulate data=simout&lin missing format=8.3 ;
	class year cf;
	var cumworkmth cumafdc cumfs hit cumearn cumben cumutil4;
	table (cumworkmth cumafdc cumfs hit cumearn cumben cumutil4)*year=''*f=7.2, cf=''*(mean='');
	title;
	where year = 10;
run;
ods html close;

%put simout&lin;
/***************************************************************************************/
/* distributional effects (see bottom of code for percentiles) */
data lrdist;
	set simout&lin;
	where year=10;
run;
/**********************************************************/
/* Table 11: distributional effects */
ods html style=minimal ;
proc tabulate data=lrdist missing format=8.3 ;
	class year cf;
	var cumworkmth cumafdc cumfs hit cumearn cumben cumutil4;
	table (cumworkmth cumafdc cumfs hit cumearn cumben cumutil4)*f=7.2, cf=''*(mean='');
	title;
	where wlin<=6.14;
run;
proc tabulate data=lrdist missing format=8.3 ;
	class year cf;
	var cumworkmth cumafdc cumfs hit cumearn cumben cumutil4;
	table (cumworkmth cumafdc cumfs hit cumearn cumben cumutil4)*f=7.2, cf=''*(mean='');
	title;
	where wlin>6.14 & wlin<=6.39;
run;
proc tabulate data=lrdist missing format=8.3 ;
	class year cf;
	var cumworkmth cumafdc cumfs hit cumearn cumben cumutil4;
	table (cumworkmth cumafdc cumfs hit cumearn cumben cumutil4)*f=7.2, cf=''*(mean='');
	title;
	where wlin>6.39;
run;
ods html close;

/***************************************************************************/
/* save datasets permanently */
proc datasets library=work;
	copy out=lr;
	select simout&lin.1 simout&lin.2 simout&lin.3 simout&lin.4 simout&lin.5 simout&lin.6 
	simout&lin.7 simout&lin.8 simout&lin.9 simout&lin.10 simout&lin.11 simout&lin.12 simout&lin.13 simout&lin.;
quit;

/***************************************************************************/
/* compute predicted wage offer 33th and 67th percentiles */
data temp999;
	set simout;
	where swave=2 & cf=1;
run;
proc univariate data=temp999;
	var wlin;
	output out=percentiles1 pctlpts=33 66 pctlpre=P;
run;
proc print data=percentiles1;run; /* output 6.14 6.39 */
