data temp;
	set dataout.fstatic;
run;

proc format;
	value unemp 
		0-1="0"
		1-2="1"
		2-3="2"
		3-4="3"
		4-5="4"
		5-6="5"
		6-7="6"
		7-8="7"
		8-9="8"
		9-10="9"
		10-100="10"
		;
run;

ods html;
proc tabulate data=temp missing;
	class yearnew value;
	table value all='',yearnew=''*pctN<value all>;
	format value unemp.;
run;
ods html close;

ods html style=minimal;
proc tabulate data=temp missing;
	class yearnew;
	var value;
	table value*(p25 p95 p50 mean p5 p75 ),yearnew;
	*format value unemp.;
run;
ods html close;

ods html style=minimal;
proc tabulate data=temp missing;
	class yearnew tmsa;
	var value;
	table tmsa*value*mean,yearnew;
	*format value unemp.;
run;
ods html close;

proc freq data=temp;
	table value;
	format value unemp.;
run;

proc chart data=temp;
	hbar value / midpoint=1 to 10 by 1;
	where year=1996;
run;
